#from Agregates import arrays_aggregates
from Aggregates import message_aggregates
from Decoder import decode_fragment

array_dictionary = {
        '6_2': 1,       '6_7': 29,
        '6_8': 10,      '6_9': 11,
        '6_11': 12,     '7': 13,
        '8_4': 14,      '8_7': 29,
        '8_9': 15,      '8_10': 11,
        '8_15': 27,     '20': 28
}

report_dictionary = {
        '0000': 16, '0001': 17, '0010': 18, '0011': 19, '0100': 20, '0101': 21, '0110': 22, '0111': 23, '1000': 24, '1001': 25, '1010': 26
    }

shape_dictionary = {
    '000': 2, '001': 3, '010': 4, '011': 5, '100': 7, '101': 9
}

def msg_type_dictionary(msg_type):
    aggregates_dictionary = {
            '1': message_aggregates.messageType_1,
            '2': message_aggregates.messageType_2,
            '3': message_aggregates.messageType_3,
            '4': message_aggregates.messageType_4,
            '5': message_aggregates.messageType_5,
            '6_1': message_aggregates.messageType_6_1,
            '6_2': message_aggregates.messageType_6_2,
            '6_3': message_aggregates.messageType_6_3,
            '6_4': message_aggregates.messageType_6_4,
            '6_5': message_aggregates.messageType_6_5,
            '6_6': message_aggregates.messageType_6_6,
            '6_7': message_aggregates.messageType_6_7,
            '6_8': message_aggregates.messageType_6_8,
            '6_9': message_aggregates.messageType_6_9,
            '6_10': message_aggregates.messageType_6_10,
            '6_11': message_aggregates.messageType_6_11,
            '6_12': message_aggregates.messageType_6_12,
            '6_13': message_aggregates.messageType_6_13,
            '6_14': message_aggregates.messageType_6_14,
            '6_15': message_aggregates.messageType_6_15,
            '7': message_aggregates.messageType_7,
            '8_1': message_aggregates.messageType_8_1,
            '8_2': message_aggregates.messageType_8_2,
            '8_3': message_aggregates.messageType_8_3,
            '8_4': message_aggregates.messageType_8_4,
            '8_5': message_aggregates.messageType_8_5,
            '8_6_1': message_aggregates.messageType_8_6_1,
            '8_6_2': message_aggregates.messageType_8_6_2,
            '8_7': message_aggregates.messageType_8_7,
            '8_8': message_aggregates.messageType_8_8,
            '8_9': message_aggregates.messageType_8_9,
            '8_10': message_aggregates.messageType_8_10,
            '8_11': message_aggregates.messageType_8_11,
            '8_12': message_aggregates.messageType_8_12,
            '8_13': message_aggregates.messageType_8_13,
            '8_14': message_aggregates.messageType_8_14,
            '8_15': message_aggregates.messageType_8_15,
            '8_16': message_aggregates.messageType_8_16,
            '9': message_aggregates.messageType_9,
            '10': message_aggregates.messageType_10,
            '11': message_aggregates.messageType_4,
            '12': message_aggregates.messageType_12,
            '13': message_aggregates.messageType_13,
            '14': message_aggregates.messageType_14,
            '15': message_aggregates.messageType_15,
            '16': message_aggregates.messageType_16,
            '17': message_aggregates.messageType_17,
            '18': message_aggregates.messageType_18,
            '19': message_aggregates.messageType_19,
            '20': message_aggregates.messageType_20,
            '21': message_aggregates.messageType_21,
            '22': message_aggregates.messageType_22,
            '23': message_aggregates.messageType_23,
            '24_A': message_aggregates.messageType_24_A,
            '24_B': message_aggregates.messageType_24_B,
            '25': message_aggregates.messageType_25,
            '25_11': message_aggregates.messageType_25,
            '25_10': message_aggregates.messageType_25,
            '25_01': message_aggregates.messageType_25,
            '25_00': message_aggregates.messageType_25,
            '26': message_aggregates.messageType_26,
            '27': message_aggregates.messageType_27
        }

    return aggregates_dictionary[msg_type]

def field_type_dictionary(fragment, field_type):

    type_dictionary = {
        'u': decode_fragment.decode_u_int(fragment),
        'e': decode_fragment.decode_u_int(fragment),
        'b': decode_fragment.decode_u_int(fragment),
        't': decode_fragment.decode_t(fragment),
        's': decode_fragment.decode_s_int(fragment),
        'I1': decode_fragment.decode_IX(fragment, 1),
        'I2': decode_fragment.decode_IX(fragment, 2),
        'I3': decode_fragment.decode_IX(fragment, 3),
        'I4': decode_fragment.decode_IX(fragment, 4),
        'U1': decode_fragment.decode_UX(fragment, 1),
        'U2': decode_fragment.decode_UX(fragment, 2),
        'd': "Binary Data",
        'z': ""
    }
   
    return type_dictionary[field_type]

