from Aggregates import message_aggregates
from Decoder import dictionaries
from . import array_decoder

class Type_switch():

    def switch_type(msg_type, message):
        single_field = ''
        field_count = len(message_aggregates.datapartsBitlengths[msg_type])
        i = 0
        position = 0
        dataParts = []

        ## Wewnętrzna pętla dla poszczególnych fragmentów wiadomości podstawowej
        ## field_count pobiera liczbę elementów w poszczególnej krotce dataBitlengths 
        while i < field_count:
            field_bits = message_aggregates.datapartsBitlengths[msg_type][i]
            field_type = message_aggregates.datapartsTypes[msg_type][i]
            fragment = message[position:(field_bits + position)]
            single_field = dictionaries.field_type_dictionary(fragment, field_type)

            ## wpisanie zdekodowanego fragmentu na końcu list dataParts
            dataParts.append(single_field)
            position += field_bits
            i += 1

        ## jeśli typ posiada typy a, to pozą powyżej ustaloną wiadomością podstawową zostanie również wywołana metoda, która pozwoli zdekodować, pozostały ciąg bitowy wiadomości
        if msg_type == '6_2' or '6_7' or '6_8' or '6_9' or '6_11' or '7' or '8_4' or '8_7' or '8_9' or '8_10' or '8_15' or '20':
            Array = array_decoder.switch_first_array(msg_type, message[position:])
            msg = dictionaries.msg_type_dictionary(msg_type)(dataParts, Array)
        else:
            msg = dictionaries.msg_type_dictionary(msg_type)(dataParts)

        return msg

        ##msg_type - typ wiadomości
        ##message - jedna wiadomość w zapisie string w zapisie binarnym
        ##position - "kursor" określający pozycje następnego fragmentu do przetworzenia
        ##fragment - pojedynczy fragment wiadomości (podzielony w zależności od wartości w krotkach dataBitlengths)
        ##field_bits - liczba bitów w elemencie krotki
        ##field_count - liczba elementów w krotce
        ##field_type - typ elementu w krotce
        ##i - licznik pętli








        
        
        
          
    
