import Reader.read_file as reader
import Decoder.array_decoder_new_version as decoder
import Printer.printer as printer

def main():
    file = open("AIS_messages.txt", "r")
    message = ""
    while message != "eof":
        message = reader.read_message(file)
        if message == "message data error":
            continue
        else:
            message_decoded = decoder.decode_message(message)
            printer.printMessage(message_decoded)
    printer.printStats(reader.get_stats())

if __name__ == "__main__":
    main()

